-- By Ashnal
-- You know how many scripts do the wierd "local k_speedboost = k_speedboost" thing?
-- Some other more dynamic globals that many mods rely on for per tic calcs also go through that super long string lookup in hardcode (lib_getenum)
-- Here, I've put all the ones that reasonably do not change during a race into a MapChange hook, so they can be put into
-- the Lua global registry where their lookups will be faster during gameplay

-- This script is why we reccommend loading this addon first

if au_globalizeharder == nil then rawset(_G, "au_globalizeharder", true) else return end

COM_AddCommand("restartlevel", function(p, ...)
	COM_BufAddText(server, "map "..G_BuildMapName(gamemap))
end, COM_ADMIN)

local optimizeleveltime, localleveltime = false

-- Don't turn this on unless you've loaded the addon as the very first addon of your load order, it defaults off since it could desync shit otherwise
local cv_leveltimeoptimize = CV_RegisterVar({
    name = "au_leveltimeoptimize",
    defaultvalue = "Off",
    flags = CV_NETVAR|CV_CALL,
    PossibleValue = CV_OnOff,
	func = function(var)
		if not optimizeleveltime and var.value then
			print("Enabling leveltime optimization...")
			optimizeleveltime = true
			localleveltime = leveltime
		elseif optimizeleveltime and not var.value then -- Optimize is already on and can't be turned off
			print("This setting cannot be turned off. Restart the game to do so.")
			COM_BufInsertText(server, "au_leveltimeoptimize On")
		end
	end
})

-- Tyron: That's fuckin illegal

local localmapnum = gamemap

addHook("MapChange", function(mapnum)
	localmapnum = mapnum
	rawset(_G,"gamemap", localmapnum)
	-- G: globalizing gamespeed like this is unsafe, because gamespeed can change mid-game, but eh...
	rawset(_G,"gamespeed", (not G_BattleGametype() and CV_FindVar("kartspeed").value or 0)) -- G: Battle forces easy speed (now you know!)
	-- G: serverplayer is always player 0... except in replays
	rawset(_G,"server", nil)
	rawset(_G,"server", server)
	rawset(_G,"mapobjectscale", mapheaderinfo[gamemap].mobj_scale) -- Use in any sort of physics and movement code usually, high impact
	localleveltime = -2
	if optimizeleveltime then
		rawset(_G,"leveltime", 0) -- We set 0 here but leave localleveltime at -2
	end
end)

addHook("NetVars", function(net)
	localleveltime = net($)
	localmapnum = net($)
	if optimizeleveltime then
		rawset(_G,"leveltime", localleveltime) -- In case someone joins during the prethinkframes where it is negative
		                                       -- G: not possible, P_PreTicker takes place entirely within map loading
	end
	-- need to do these here since joiners don't run MapLoad/MapChange -- Holy shit I just realized you can substitute a NetVars hook for Mapload/MapChange specifically for joiners ...
	rawset(_G,"gamemap", localmapnum)
	rawset(_G,"gamespeed", (not G_BattleGametype() and CV_FindVar("kartspeed").value or 0))
	rawset(_G,"server", players[0])
	rawset(_G,"mapobjectscale", mapheaderinfo[gamemap].mobj_scale)
end)

-- G: leveltime MUST be incremented in PostThinkFrame, when all thinkers have already ran
-- otherwise, other MobjThink/ThinkFrame hooks after us will have leveltime incremented too early
-- other PostThinkFrame hooks? No problem, assuming our hook runs first
addHook("PostThinkFrame", do
	if optimizeleveltime then
		localleveltime = $ + 1
		if localleveltime > 0 then
			rawset(_G,"leveltime", localleveltime)
		end
	end
end)

--[[
addHook("ThinkFrame", do
	if optimizeleveltime then
		print("Real leveltime: "..leveltime)
		print("Localleveltime: "..localleveltime)
	end
end)
--]]
