-- By Ashnal
-- Rotates maps periodically whenever the server is empty

-- This file has been edited for Sunflower's Garden. Please do not use it and grab the original:
-- https://mb.srb2.org/addons/ashnals-utilities-fixes.3607/

if au_maprotate == nil then rawset (_G, "au_maprotate", true) else return end

local cv_maprotate = CV_RegisterVar({
    name = "au_maprotate",
    defaultvalue = "On",
    flags = CV_NETVAR, -- Doesnt really matter, but this will let clients know its on
    PossibleValue = CV_OnOff
})

local VOTE = 3

local count
local function ActivePlayers()
	count = 0
	for p in players.iterate do
		if p.spectator then continue end
		count = $ + 1
	end
	return count
end

local localleveltime = 0
local active, lastactive
addHook("ThinkFrame", function()
	if not cv_maprotate.value then return end
    localleveltime = localleveltime + 1
	active = ActivePlayers()
	--if localleveltime > 157500 and not active then -- If you've been in a map longer than 15 minutes and no players. Modified to be longer so I don't get replay spammed
    --    -- It should be set in mapchange but it seems even when you change map,
    --    -- ThinkFrame executes at least one more time, so if we don't want to
    --    -- change level >= 2 times, we'll just set localleveltime to 0 here.
    --    localleveltime = 0
    --  if CV_FindVar("advancemap").value == VOTE then -- If set to vote and there are no players, exitlevel will just go to nextmap instead of random when exitlevel is called, so we fix that here
	--		COM_BufAddText(server, "map "..G_BuildMapName(0)) -- Randommap trick from hostmod
	--	else
	--		COM_BufInsertText(server, "exitlevel")
	--	end
	if not lastactive and active and localleveltime > 236 and CV_FindVar("spbatk") and CV_FindVar("spbatk").value == 0 then -- This restarts a level when a player first enters
		COM_BufInsertText(server, "restartlevel")
	end
	lastactive = active
end)

-- It is set to 0 in ThinkFrame, but it still required, in case map were changed
-- by admin
addHook("MapChange", function()
    localleveltime = 0
end)
